library(startR)
repos_obs <- '/esarchive/obs/ukmo/hadisst_v1.1/monthly_mean/$var$/$var$_$date$.nc'

obs <- Start(dat = repos_obs,
             var = 'tos',
             date = '200505',
             time = 'all',
             lat = values(list(-10, 10)),  # if use indices(), no bug
             lat_reorder = Sort(),
             lon = values(list(10, 20)),
             lon_reorder = CircularSort(0, 360),
             time_across = 'date',
             #combine time and file_date dims 
             merge_across_dims = TRUE,
             #exclude the additional NAs generated by merge_across_dims
             merge_across_dims_narm = TRUE,
             synonims = list(lat = c('lat', 'latitude'),
                             lon = c('lon', 'longitude')),
             return_vars = list(latitude = NULL,  # the name should be lat
                                longitude = NULL,
                                time = 'date'),
             retrieve = TRUE)

names(attr(obs, 'Variables')$common)

